result = {
	Create = function(self, prefix, parent)
		local frame = CreateFrame("GameTooltip", "LH_Result", UIParent, "GameTooltipTemplate")
		frame.name = "LH_Result"
		frame.itemLink = itemLink
		frame.updateTooltip = 0.2
		frame.needsReset = true
		frame.prefix = prefix
		frame.parent = parent
		frame:SetClampRectInsets(0, 0, 0, -50)
		local compare1 = CreateFrame("GameTooltip", frame.name.."_Compare1", frame, "GameTooltipTemplate")
		-- ShoppingTooltipTemplate
		compare1:SetPoint("TOPLEFT", frame, "TOPRIGHT", 2, 0)
		compare1:SetFrameStrata("TOOLTIP")
		local compare2 = CreateFrame("GameTooltip", frame.name.."_Compare2", frame, "GameTooltipTemplate")
		compare2:SetPoint("TOPLEFT", compare1, "TOPRIGHT", 2, 0)
		compare2:SetFrameStrata("TOOLTIP")
		frame.shoppingTooltips = { compare1, compare2 }

		
		--[[
		frame.SetCompare = function(self,triger,displayframe)
			hooksecurefunc(frame, "SetHyperlink",
			function(self, ItemLink, ...)
				-- Attach an icon to the tooltip first so that an existing icon can be hidden if the new hyperlink doesn't have one.
				PawnAttachIconToTooltip(frame, false, ItemLink)
				if IsEquippableItem(ItemLink) then
					PawnUpdateTooltip(frame.name, "SetHyperlink", ItemLink, ...)
					-- PawnUpdateTooltip(frame.name, "SetCompareItem", ItemLink, ...)
				end
			end )
			frame:HookScript("OnEnter", function() local _; _, PawnLastHoveredItem = frame:GetItem() end)
			frame:HookScript("OnLeave", function() PawnLastHoveredItem = nil end)
			frame:HookScript("OnMouseUp",
			function(object, button)
				if button == "RightButton" then
					local _, ItemLink = frame:GetItem()
					PawnUI_SetCompareItemAndShow(2, ItemLink)
				end
			end
			)

			hooksecurefunc(compare1, "SetCompareItem",
			function(self, ...)
				local _, ItemLink1 = compare1:GetItem()
				PawnUpdateTooltip("LH_Result_Compare1", "SetCompareItem", ItemLink1, ...)
				PawnAttachIconToTooltip(compare1, true)

				local _, ItemLink2 = compare2:GetItem()
				if ItemLink2 and compare1:IsShown() then
					PawnUpdateTooltip("LH_Result_Compare2", "SetCompareItem", ItemLink2, ...)
					PawnAttachIconToTooltip(compare2, true)
				end
			end
			)
		end
		--if IsAddOnLoaded("Pawn") then
		--	frame.SetCompare(frame,frame); 
		--end
		--]]

		--[[
		if IsAddOnLoaded("Pawn") then
			hooksecurefunc(frame, "SetHyperlink",
			function(self, ItemLink, ...)
				-- Attach an icon to the tooltip first so that an existing icon can be hidden if the new hyperlink doesn't have one.
				PawnAttachIconToTooltip(frame, false, ItemLink)
				if IsEquippableItem(ItemLink) then
					PawnUpdateTooltip(frame.name, "SetHyperlink", ItemLink, ...)
					-- PawnUpdateTooltip(frame.name, "SetCompareItem", ItemLink, ...)
				end
			end )
			frame:HookScript("OnEnter", function() local _; _, PawnLastHoveredItem = frame:GetItem() end)
			frame:HookScript("OnLeave", function() PawnLastHoveredItem = nil end)
			frame:HookScript("OnMouseUp",
			function(object, button)
				if button == "RightButton" then
					local _, ItemLink = frame:GetItem()
					PawnUI_SetCompareItemAndShow(2, ItemLink)
				end
			end
			)

			hooksecurefunc(compare1, "SetCompareItem",
			function(self, ...)
				local _, ItemLink1 = compare1:GetItem()
				PawnUpdateTooltip("LH_Result_Compare1", "SetCompareItem", ItemLink1, ...)
				PawnAttachIconToTooltip(compare1, true)

				local _, ItemLink2 = compare2:GetItem()
				if ItemLink2 and compare1:IsShown() then
					PawnUpdateTooltip("LH_Result_Compare2", "SetCompareItem", ItemLink2, ...)
					PawnAttachIconToTooltip(compare2, true)
				end
			end
			)
			
		end
		--]]
		frame:SetWidth(100)
		frame:SetHeight(100)
		frame:SetPoint("CENTER", 0, 0)
		frame:SetMovable(true)
		frame:EnableMouse(true)
		frame:SetMovable(true)
		frame:SetToplevel(true)
		frame:SetUserPlaced(true)
		frame:SetScript("OnMouseDown",
		function(self, button)
			self:StartMoving()
		end
		)
		frame:SetScript("OnMouseUp",
		function(self, button)
			self:StopMovingOrSizing()
		end
		)

		frame:SetScript("OnEnter",
		function(self, motion)
			self.comparing = true
		end
		)


		frame:SetScript("OnLeave",
		function(self, motion)
			self.comparing = false
		end
		)
		frame:SetScript("OnUpdate",
		function(self, e)
			local shoppingTooltip1, shoppingTooltip2 = unpack(self.shoppingTooltips)
			--if (self.comparing and IsModifiedClick("COMPAREITEMS")) then
				--self:SetCompareItem()
				self.buttons[1]:CompareItem(1,GetContainerItemLink(0, 15))
				self.buttons[1]:CompareItem(2,GetContainerItemLink(0, 14))
				self.buttons[2]:CompareItem(1,GetContainerItemLink(0, 14))
				self.buttons[2]:CompareItem(2,GetContainerItemLink(0, 15))


				local s1l = shoppingTooltip1:GetLeft()
				local s1r = shoppingTooltip1:GetRight()
				local s1w = shoppingTooltip1:GetWidth()
				local s2l = shoppingTooltip2:GetLeft()
				local s2r = shoppingTooltip2:GetRight()
				local s2w = shoppingTooltip2:GetWidth()
				local sl = self:GetLeft()
				local sr = self:GetRight()
				local sw = self:GetWidth()
				-- Right Side

				if s2r ~= nil and s1r ~= nil and s2l ~= nil and s1l ~= nil and sr ~= nil and s1w ~= nil and s2w ~= nil and sw ~= nil then
					if s2r > s1r and s2l < s1r and s1l > sr then
						shoppingTooltip2:SetPoint("TOPLEFT", shoppingTooltip1, "TOPRIGHT", -1 *(sw + s1w + s2w + 4), 0)
						return
					end
				end
				if s2l ~= nil and sr ~= nil and s2r ~= nil and s1r ~= nil and sl ~= nil and s1w ~= nil and s2w ~= nil then
					if s2l < sr and s2r > sr and s1r < sl then
						shoppingTooltip2:SetPoint("TOPLEFT", shoppingTooltip1, "TOPRIGHT", -1 *(s1w + s2w + 4), 0)
						return
					end
				end
				if s1l ~= nil and sr ~= nil and s1r ~= nil and sl ~= nil then
					if s1l < sr and s1r > sr then

						if s1w ~= nil and sw ~= nil then
							shoppingTooltip1:SetPoint("TOPLEFT", frame, "TOPRIGHT", -1 *(s1w + sw + 4), 0)
						end
						if s1w ~= nil and s2w ~= nil and s2r ~= nil then
							if s2r < sl then
								shoppingTooltip2:SetPoint("TOPLEFT", shoppingTooltip1, "TOPRIGHT", -1 *(s1w + s2w + 4), 0)
							end
						end
						return
					end
				end
				-- Left Side
				if s2r ~= nil and sl ~= nil and s2l ~= nil and s1l ~= nil and sr ~= nil then
					if s2r > sl and s2l < sl and s1l > sr then
						shoppingTooltip2:SetPoint("TOPLEFT", shoppingTooltip1, "TOPRIGHT", 2, 0)
						return
					end
				end
				if s2r ~= nil and s1l ~= nil and s2l ~= nil and s1r ~= nil and sl ~= nil and sw ~= nil then
					if s2r > s1l and s2l < s1l and s1r < sl then
						shoppingTooltip2:SetPoint("TOPLEFT", shoppingTooltip1, "TOPRIGHT", sw + 6, 0)
						return
					end
				end
				if s1r ~= nil and sl ~= nil and s1l ~= nil and sr ~= nil then
					if s1r > sl and s1l < sl then
						shoppingTooltip1:SetPoint("TOPLEFT", frame, "TOPRIGHT", 2, 0)

						if s2l ~= nil and s2l > sr then
							shoppingTooltip2:SetPoint("TOPLEFT", shoppingTooltip1, "TOPRIGHT", 2, 0)
						end
						return
					end
				end
			--[[
			elseif (not self.comparing or not IsModifiedClick("COMPAREITEMS")) then
				-- local shoppingTooltip1, shoppingTooltip2 = unpack(self.shoppingTooltips)
				shoppingTooltip1:Hide()
				shoppingTooltip2:Hide()
			end
			--]]
		end
		)


		frame.title = frame:CreateFontString("LH_Result_Title", "ARTWORK")
		frame.title:SetPoint("BOTTOMLEFT", frame, "TOPLEFT", 0, 5)
		frame.title:SetWidth(frame:GetWidth())
		frame.title:SetHeight(22)
		frame.title:SetTextColor(0.9, 0.52, 0.13, 1)
		frame.title:SetFont("Fonts\\FRIZQT__.TTF", 20, nil)

		frame.SetTitle = function(self, str)
			self.title:SetTextColor(0.9, 0.52, 0.13, 1)
			self.title:SetFont("Fonts\\FRIZQT__.TTF", 20, nil)
			self.title:SetText(str);
		end
		frame.btnRoll = CreateFrame("Button", "LH_Result_Btn)Close", frame, "UIPanelButtonTemplate")
		frame.btnRoll:SetPoint("TOPRIGHT", -5, 5)
		frame.btnRoll:SetWidth(20)
		frame.btnRoll:SetHeight(20)
		frame.btnRoll:SetText("X")
		frame.btnRoll:SetScript("OnClick",
		function(self, button, down)
			frame:HideFrame()
		end
		)
		

		frame.SetCompareItem = function(self)
			if self.needsReset then
				self:ResetSecondaryCompareItem()
				self:AdvanceSecondaryCompareItem()
				self.needsReset = false;
			end
			local shoppingTooltip1, shoppingTooltip2 = unpack(self.shoppingTooltips)
			local primaryItemShown, secondaryItemShown = shoppingTooltip1:SetCompareItem(shoppingTooltip2, self)
		end


		frame.SetInfo = function(self, itemLink)
			self.itemLink = itemLink
			ShowFrame()
		end

		t = {}
		t[1] = "M"
		t[2] = 44
		t[3] = "Liary"
		t[4] = GetContainerItemLink(0, 15)
		t[5] = GetContainerItemLink(0, 14)
		t1 = {}
		t1[1] = "M"
		t1[2] = 54
		t1[3] = "Someone"
		t1[4] = GetContainerItemLink(0, 14)
		t1[5] = nil

		frame.rollers = {t,t1}
		frame.buttons = {}
		frame.CreateRollers= function (self,t)
			local height = 22
			local width = 150
			for i,j in pairs(t) do
				-- init
				local b = CreateFrame("Button",j[3],UIPanel,"UIPanelButtonTemplate")
				b:SetText(j[1].."  "..j[2].."  "..j[3])
				b.frame = self
				b.rollType = j[1]
				b.rolled = j[2]
				b.name = j[3]
				b.com1 = j[4]
				b.com2 = j[5]
				b:SetWidth(width)
				b:SetHeight(height)

				-- location
				b:SetPoint("BOTTOMLEFT",self,"BOTTOMLEFT",0,-1*i*height);

				b:SetScript("OnMouseDown",
					function(self, button)
						for k,l in pairs(self.frame.buttons) do
							l:Hide()
						end
						self.frame:HideFrame()
					end
				)
				
				b.CompareItem = function(self,itemNum,itemLink)
					if itemNum == 1 then 
						self.com1 = itemLink
					elseif itemNum == 2 then
						self.com2 = itemLink
					end
				end
				


				b:SetScript("OnEnter",
					function(self, motion)
						self.frame:SetCompareItem()

						local compare1, compare2 = unpack(self.frame.shoppingTooltips)

						if self.com1 ~= nil then

							ShowUIPanel(compare1);
							if (not compare1:IsVisible()) then
								compare1:SetOwner(UIParent, "ANCHOR_PRESERVE")
							end
							compare1:ClearLines()
							compare1:SetHyperlink(self.com1)
							compare1:Show()

							compare1:Show()
						else
							compare1:Hide()
						end


						if self.com2 ~= nil then
							ShowUIPanel(compare2);
							if (not compare2:IsVisible()) then
								compare2:SetOwner(UIParent, "ANCHOR_PRESERVE")
							end
							compare2:ClearLines()
							compare2:SetHyperlink(self.com2)
							compare2:Show()
						else
							compare2:Hide()
						end
						
					end
				)

				b:SetScript("OnLeave",
					function(self, motion)
					local compare1, compare2 = unpack(self.frame.shoppingTooltips)
						compare1:Hide()
						compare2:Hide()
					end
				)
				

				b:Show()
				table.insert(self.buttons,b);
			end
		end



		frame.ShowFrame = function(self, player, itemLink)
			if itemLink ~= nil then
				ShowUIPanel(self);
				if (not self:IsVisible()) then
					self:SetOwner(UIParent, "ANCHOR_PRESERVE")
				end
				self:ClearLines()
				self:SetHyperlink(itemLink)
				self:Show()

				if (self:GetWidth() < 213) then 
					self:SetWidth(213) 
					--frame.btnPass:SetPoint("BOTTOMRIGHT",frame.btnRoll_T,"BOTTOMRIGHT", frame.btnPass:GetWidth()+10, 0)
				end
				
				
				--self:SetHeight(self:GetHeight() + 50)
				self:SetTitle(player)
				--self.title:Show()
				--self.btnPass:Show()
				--self.btnRoll:Show()
				self:CreateRollers(self.rollers)

			end
		end
		frame.HideFrame = function(self)
			--self.title:Hide()
			--self.btnRoll:Hide()
			--self.btnPass:Hide()
			--frame.btnPass:SetPoint("BOTTOMRIGHT", -5, -45)
			self:Hide()

		end
		return frame
	end
}

